/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.io;

import java.io.*;
import java.util.*;

import jp.ossc.nimbus.beans.dataset.Record;
import jp.ossc.nimbus.beans.dataset.RecordSchema;
import jp.ossc.nimbus.beans.dataset.PropertySetException;
import jp.ossc.nimbus.util.converter.PaddingStringConverter;

/**
 * FLV（Fixed Length Value）形式のストリームを{@link Record}として読み込むReaderクラス。<p>
 * <pre>
 * import java.io.*;
 * import jp.ossc.nimbus.io.FLVRecordReader;
 * import jp.ossc.nimbus.beans.dataset.Record;
 * import jp.ossc.nimbus.beans.dataset.RecordSchema;
 *
 * FileInputStream fis = new FileInputStream("sample.csv");
 * InputStreamReader isr = new InputStreamReader(fis, "UTF-8");
 * FLVRecordReader reader = new FLVRecordReader(isr);
 * reader.setFieldLength(new int[]{5,10});
 * reader.setEncoding("UTF-8");
 * Record record = new Record(":a,java.lang.String\n:b,int");
 * reader.setRecordSchema(record.getRecordSchema());
 * try{
 *     while((record = reader.readRecord(record)) != null){
 *         String a = record.getStringProperty("a");
 *         int b = record.getIntProperty("b");
 *             :
 *     }
 * }finally{
 *     reader.close();
 * }
 * </pre>
 * 
 * @author M.Takata
 */
public class FLVRecordReader extends FLVReader{
    
    private RecordSchema schema;
    private List<String> workList;
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     */
    public FLVRecordReader(){
        super();
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(int... fieldLen){
        super(fieldLen);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param fieldLen フィールド長の配列
     * @param encoding 文字エンコーディング
     */
    public FLVRecordReader(String encoding, int... fieldLen){
        super(encoding, fieldLen);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(String encoding, int[] fieldLen, PaddingStringConverter[] convs){
        super(encoding, fieldLen, convs);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(String encoding, RecordSchema schema, int... fieldLen){
        super(encoding, fieldLen);
        setRecordSchema(schema);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(String encoding, RecordSchema schema, int[] fieldLen, PaddingStringConverter[] convs){
        super(encoding, fieldLen, convs);
        setRecordSchema(schema);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     */
    public FLVRecordReader(Reader reader){
        super(reader);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(Reader reader, int... fieldLen){
        super(reader, fieldLen);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(Reader reader, String encoding, int... fieldLen){
        super(reader, encoding, fieldLen);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(Reader reader, String encoding, int[] fieldLen, PaddingStringConverter[] convs){
        super(reader, encoding, fieldLen, convs);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(Reader reader, String encoding, RecordSchema schema, int... fieldLen){
        super(reader, encoding, fieldLen);
        setRecordSchema(schema);
    }
    
    /**
     * デフォルトの読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(Reader reader, String encoding, RecordSchema schema, int[] fieldLen, PaddingStringConverter[] convs){
        super(reader, encoding, fieldLen, convs);
        setRecordSchema(schema);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     */
    public FLVRecordReader(int size){
        super(size);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(int size, int... fieldLen){
        super(size, fieldLen);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(int size, String encoding, int... fieldLen){
        super(size, encoding, fieldLen);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(int size, String encoding, int[] fieldLen, PaddingStringConverter[] convs){
        super(size, encoding, fieldLen, convs);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(int size, String encoding, RecordSchema schema, int... fieldLen){
        super(size, encoding, fieldLen);
        setRecordSchema(schema);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つ未接続のインスタンスを生成する。<p>
     *
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(int size, String encoding, RecordSchema schema, int[] fieldLen, PaddingStringConverter[] convs){
        super(size, encoding, fieldLen, convs);
        setRecordSchema(schema);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     */
    public FLVRecordReader(Reader reader, int size){
        super(reader, size);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     * @param fieldLen フィールド長の配列
     */
    public FLVRecordReader(Reader reader, int size, int... fieldLen){
        super(reader, size, fieldLen);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     * @param fieldLen フィールド長の配列
     * @param encoding 文字エンコーディング
     */
    public FLVRecordReader(Reader reader, int size, String encoding, int... fieldLen){
        super(reader, size, encoding, fieldLen);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(Reader reader, int size, String encoding, int[] fieldLen, PaddingStringConverter[] convs){
        super(reader, size, encoding, fieldLen, convs);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     * @param fieldLen フィールド長の配列
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     */
    public FLVRecordReader(Reader reader, int size, String encoding, RecordSchema schema, int... fieldLen){
        super(reader, size, encoding, fieldLen);
        setRecordSchema(schema);
    }
    
    /**
     * 指定された読み込みバッファサイズを持つインスタンスを生成する。<p>
     *
     * @param reader 読み込み元のReader
     * @param size 読み込みバッファサイズ
     * @param encoding 文字エンコーディング
     * @param schema レコードスキーマ
     * @param fieldLen フィールド長の配列
     * @param convs フィールドのパディングを解除するコンバータ配列
     */
    public FLVRecordReader(Reader reader, int size, String encoding, RecordSchema schema, int[] fieldLen, PaddingStringConverter[] convs){
        super(reader, size, encoding, fieldLen, convs);
        setRecordSchema(schema);
    }
    
    /**
     * 読み込むFLV形式文字列のスキーマを設定する。<p>
     *
     * @param schema スキーマ
     * @see #readRecord()
     */
    public void setRecordSchema(RecordSchema schema){
        this.schema = schema;
        workList = new ArrayList<String>(schema.getPropertySize());
    }
    
    /**
     * 読み込むFLV形式文字列のレコードスキーマを取得する。<p>
     *
     * @return スキーマ
     */
    public RecordSchema getRecordSchema(){
        return schema;
    }
    
    /**
     * 予め設定されたレコードスキーマを使って、FLV行を1行、レコードとして読み込む。<p>
     *
     * @return FLV要素を格納したレコード
     * @exception IOException 入出力エラーが発生した場合
     * @exception PropertySetException FLV形式の要素文字列のパースに失敗した場合
     * @see #setRecordSchema(RecordSchema)
     */
    public Record readRecord() throws IOException, PropertySetException{
        List<String> flv = readFLVLineList(workList);
        if(flv == null){
            return null;
        }
        Record record = new Record(getRecordSchema());
        return readRecord(record);
    }
    
    /**
     * FLV行を1行、レコードとして読み込む。<p>
     * FLV要素の値を格納するレコードを再利用するためのメソッドである。<br>
     *
     * @param record FLV要素の値を格納するレコード
     * @return FLV要素を格納したレコード
     * @exception IOException 入出力エラーが発生した場合
     * @exception PropertySetException FLV形式の要素文字列のパースに失敗した場合
     */
    public Record readRecord(Record record) throws IOException, PropertySetException{
        if(workList == null){
            workList = new ArrayList<String>();
        }
        List<String> flv = readFLVLineList(workList);
        if(flv == null){
            return null;
        }
        if(record == null){
            record = new Record(getRecordSchema());
        }else{
            record.clear();
        }
        for(int i = 0, imax = Math.min(flv.size(), record.size()); i < imax; i++){
            String element = flv.get(i);
            record.setParseProperty(i, element);
        }
        return record;
    }
    
    /**
     * 未接続の複製を生成する。<p>
     *
     * @return 未接続の複製
     */
    public FLVReader cloneReader(){
        return cloneReader(new FLVRecordReader());
    }
    
    /**
     * 未接続の複製を生成する。<p>
     *
     * @param clone 未接続のインスタンス
     * @return 未接続の複製
     */
    protected FLVReader cloneReader(FLVReader clone){
        clone = super.cloneReader(clone);
        ((FLVRecordReader)clone).schema = schema;
        return clone;
    }
}
